Subject: Re: [PATCH v6 2/2] refs.c: SSE4.2 optimizations for check_refname_component

From: David Turner <[email-masked]>
Date: Wed, 04 Jun 2014 17:16:00 -0400

On Wed, 2014-06-04 at 16:25 +0200, Torsten Bögershausen wrote:
> On the other hand, looking here: 
> http://sourceware.org/ml/libc-alpha/2009-10/msg00063.html
> and looking into refs.c,
> it seems as if we can try to run 
> strcspn(refname, bad_characters)
> and 
> strstr(refname, "@{"
> and 
> strstr(refname, ".."
> on each refname, instead of checking each char in a loop.
> The library will pick the fastest version for strcspn() automatically.

Yes, you could try that, but I worry that it would be less efficient,
because it duplicates the looping machinery.

> David, the repo you run the tests on, is it public?

Unfortunately, it is an internal Twitter repo.

> Or is there a public repo with this many refs ?

I do not know of one.

> Or can you make a dummy repo with 60k refs ?

Sure!  I actually went with > 120k to make measurement easier:
https://github.com/dturner-tw/many-refs